/**
 * Copyright (C) 2014 Roman Hiestand
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef PJDROPTARGETWIN32_H
#define PJDROPTARGETWIN32_H

class wxPackJPGMainFrame;
class PJOLEClassFactory;

#include "pjoledefs.h"

class PJDropTargetWin32
{
public:
	PJDropTargetWin32();
	virtual ~PJDropTargetWin32();
	void setMainFrame(wxPackJPGMainFrame *pWxPackJPGMainFrame);

	void OpenFilesFromDataObject(IDataObject *pdto);
	void addFile(const wxString &filename);
	void addFiles(const wxArrayString &filenames);
	void startCommand(wxPackJPG_OLE_Commands cmd, const wxString &pathStr = wxEmptyString);

	static void registerServer();
	static void unregisterServer();

private:
	wxPackJPGMainFrame *pMainFrame_;

	PJOLEClassFactory *pPJOCF_;
	HRESULT hrRegister_;
	DWORD dwRegisterCookie_;
};

#endif
