/**
 * Copyright (C) 2014 Roman Hiestand
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include "CommonIncludes.h"
#include "PJOverwriteDialog.h"

PJOverwriteDialog::PJOverwriteDialog(wxWindow* parent, const wxString &filename)
	: PJOverwriteDialogBase(parent),
	outFilename_(filename)
{
	pOverwriteStaticText_->SetLabel(
		wxString(wxT("The file "))
		+ outFilename_
		+ wxT(" already exists.\nDo you want to overwrite this file?"));

	this->Fit();		// If the filename is very long, adjust the size of the dialog
	this->Layout();
}

PJOverwriteDialog::~PJOverwriteDialog()
{
}

void PJOverwriteDialog::OnYesToAllButton( wxCommandEvent& event )
{
	EndModal(wxID_YESTOALL);
}

void PJOverwriteDialog::OnYesButton( wxCommandEvent& event )
{
	EndModal(wxID_YES);
}

void PJOverwriteDialog::OnNoButton( wxCommandEvent& event )
{
	EndModal(wxID_NO);
}

// Cancel/Close button is handled by wxWidgets
