// packJPGlib.h - function declarations for the packJPG library
#if defined BUILD_DLL
	#define EXPORT __declspec( dllexport )
#else
	#define EXPORT extern
#endif

/* -----------------------------------------------
	function declarations: library only functions
	----------------------------------------------- */

EXPORT void *pjglib_alloc_work_area( void );
EXPORT void pjglib_free_work_area( void *wa );

// err_tol: error threshold ( proceed on warnings yes (2) / no (1) )
// disc_meta: discard meta-info yes / no
EXPORT void pjglib_adjust_settings( int err_tol, bool disc_meta, void *wa );
EXPORT bool pjglib_convert_stream2stream( char* msg, void *wa );
EXPORT bool pjglib_convert_file2file( char* in, char* out, char* msg, void *wa );
EXPORT bool pjglib_convert_stream2mem( unsigned char** out_file, unsigned int* out_size, char* msg, void *wa );
EXPORT void pjglib_init_streams( void* in_src, int in_type, int in_size, void* out_dest, int out_type, void *wa );
EXPORT const char* pjglib_version_info( void );
EXPORT const char* pjglib_short_name( void );

/* a short reminder about input/output stream types
   for the pjglib_init_streams() function
	
	if input is file
	----------------
	in_scr -> name of input file
	in_type -> 0
	in_size -> ignore
	
	if input is memory
	------------------
	in_scr -> array containg data
	in_type -> 1
	in_size -> size of data array
	
	if input is *FILE (f.e. stdin)
	------------------------------
	in_src -> stream pointer
	in_type -> 2
	in_size -> ignore
	
	vice versa for output streams! */
