#ifndef VERSION_H
#define VERSION_H

#define PJ_STRINGIFY2(x) #x
#define PJ_STRINGIFY(x) PJ_STRINGIFY2(x)

#define WX_PACK_JPG_VERSION_MAJOR 1
#define WX_PACK_JPG_VERSION_MINOR 2
#define WX_PACK_JPG_VERSION_BUILD 0

#define WX_PACK_JPG_VERSION_STRING PJ_STRINGIFY(WX_PACK_JPG_VERSION_MAJOR) \
	"." PJ_STRINGIFY(WX_PACK_JPG_VERSION_MINOR) \
	"." PJ_STRINGIFY(WX_PACK_JPG_VERSION_BUILD)

#define WX_PACK_JPG_NAME "wxPackJPG"
#define WX_PACK_JPG_COPYRIGHT_NAME "Roman Hiestand"
#define WX_PACK_JPG_COPYRIGHT_YEAR "2014"

// The check for __INTEL_COMPILER needs to be before _MSC_VER and __GNUG__, as
// the Intel compiler defines _MSC_VER and __GNUG__ as well
#if defined(__INTEL_COMPILER)
#	define WX_PACK_JPG_COMPILER "Intel C++"
#	define WX_PACK_JPG_COMPILER_VERSION PJ_STRINGIFY(__INTEL_COMPILER)
#elif defined(_MSC_VER)
#	define WX_PACK_JPG_COMPILER "Visual C++"
#	define WX_PACK_JPG_COMPILER_VERSION PJ_STRINGIFY(_MSC_FULL_VER)
#elif defined(__clang__)
#	define WX_PACK_JPG_COMPILER "Clang"
#	define WX_PACK_JPG_COMPILER_VERSION PJ_STRINGIFY(__clang_major__) "." PJ_STRINGIFY(__clang_minor__) "." PJ_STRINGIFY(__clang_patchlevel__)
#elif defined(__GNUG__)
#	define WX_PACK_JPG_COMPILER "GCC"
#	if defined(__GNUC_PATCHLEVEL__)
#		define WX_PACK_JPG_COMPILER_VERSION PJ_STRINGIFY(__GNUC__) "." PJ_STRINGIFY(__GNUC_MINOR__) "." PJ_STRINGIFY(__GNUC_PATCHLEVEL__)
#	else
#		define WX_PACK_JPG_COMPILER_VERSION PJ_STRINGIFY(__GNUC__) "." PJ_STRINGIFY(__GNUC_MINOR__)
#	endif
#else
#	define WX_PACK_JPG_COMPILER "Unknown compiler"
#	define WX_PACK_JPG_COMPILER_VERSION "Unknown version"
#endif

// Architecture
#if defined(_M_X64) || defined(_M_AMD64) || defined(__amd64__) || defined(__amd64) || defined(__x86_64__) || defined(__x86_64)
#define WX_PACK_JPG_ARCHITECTURE_X64
#define WX_PACK_JPG_ARCHITECTURE_STRING "x64"
#elif defined(_M_ARM) || defined(__arm__) || defined(_ARM)
#define WX_PACK_JPG_ARCHITECTURE_ARM
#define WX_PACK_JPG_ARCHITECTURE_STRING "ARM"
#elif defined(_M_IX86) || defined(__i386) || defined(__i486__) || defined(__i586__) || defined(__i686__) || defined(_X86_)
#define WX_PACK_JPG_ARCHITECTURE_X86
#define WX_PACK_JPG_ARCHITECTURE_STRING "x86"
#elif defined(_M_IA64) || defined(__ia64__) || defined(_IA64) || defined(__IA64__) || defined(__ia64)
#define WX_PACK_JPG_ARCHITECTURE_ITANIUM
#define WX_PACK_JPG_ARCHITECTURE_STRING "Itanium"
#elif defined(_M_PPC) || defined(__powerpc) || defined(__powerpc__) || defined(__powerpc64__) || defined(__POWERPC__) || defined(__ppc__) || defined(__ppc64__)
#define WX_PACK_JPG_ARCHITECTURE_PPC
#define WX_PACK_JPG_ARCHITECTURE_STRING "PPC"
#elif defined(__sparc__) || defined(__sparc)
#define WX_PACK_JPG_ARCHITECTURE_SPARC
#define WX_PACK_JPG_ARCHITECTURE_STRING "SPARC"
#endif

#endif
